<template>
	<el-dialog v-model="visible" :title="!dataForm.id ? '新增' : '修改'" :close-on-click-modal="false">
		<el-form ref="dataFormRef" :model="dataForm" :rules="dataRules" label-width="100px" @keyup.enter="submitHandle()">
			<el-form-item label="用户编号" prop="userId">
				<el-input v-model="dataForm.userId" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="书籍编号" prop="bookId">
				<el-input v-model="dataForm.bookId" placeholder=""></el-input>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible = false">取消</el-button>
			<el-button type="primary" @click="submitHandle()">确定</el-button>
		</template>
	</el-dialog>
</template>
<script setup lang="ts">
import { reactive, ref } from 'vue'
import { ElMessage } from 'element-plus/es'
import { useT_book_collectionApi, useT_book_collectionSubmitApi } from '@/api/maku/t_book_collection'
const emit = defineEmits(['refreshDataList'])
const visible = ref(false)
const dataFormRef = ref()
const dataForm = reactive({
	id: '',
	userId: '',
	bookId: '',
	createTime: '',
	updateTime: ''
})

const init = (id?: number) => {
	visible.value = true
	dataForm.id = ''

	// 重置表单数据
	if (dataFormRef.value) {
		dataFormRef.value.resetFields()
	}

	if (id) {
		getT_book_collection(id)
	}
}

const getT_book_collection = (id: number) => {
	useT_book_collectionApi(id).then(res => {
		Object.assign(dataForm, res.data)
	})
}

const dataRules = ref({
	userId: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	bookId: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	
})

// 表单提交
const submitHandle = () => {
	dataFormRef.value.validate((valid: boolean) => {
		if (!valid) {
			return false
		}

		useT_book_collectionSubmitApi(dataForm).then(() => {
			ElMessage.success({
				message: '操作成功',
				duration: 500,
				onClose: () => {
					visible.value = false
					emit('refreshDataList')
				}
			})
		})
	})
}

defineExpose({
	init
})
</script>
